## ovito 0.9.2

=== CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

PROJECT(ovito)

# Make sure we have a new version of CMake
CMAKE_MINIMUM_REQUIRED(VERSION 2.4 FATAL_ERROR)
IF(COMMAND cmake_policy)
	CMAKE_POLICY(SET CMP0003 NEW)
	IF(POLICY CMP0011)
		CMAKE_POLICY(SET CMP0011 NEW)
	ENDIF(POLICY CMP0011)
ENDIF(COMMAND cmake_policy)

# Force out-of-source build
STRING(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" OVITO_IN_SOURCE)
IF(OVITO_IN_SOURCE)
	MESSAGE(FATAL_ERROR "OVITO requires an out of source build. Please create a separate build directory and run 'cmake path_to_ovito [options]' there.")
ENDIF(OVITO_IN_SOURCE)

# Select the Release build configuration by default.
IF(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE "Release")
ENDIF(NOT CMAKE_BUILD_TYPE)

# This CMake file defines the options that control which parts of the application will be built.
INCLUDE(OvitoConfig.cmake)

# This is the base directory for all included header files.
INCLUDE_DIRECTORIES(${OVITO_INCLUDE_PATHS})

# Place all compiled libraries into OVITO's library directory.
SET(LIBRARY_OUTPUT_PATH "${OVITO_LIBRARY_DIRECTORY}")

# Get the current revision number from the Subversion repository.
FIND_PACKAGE(Subversion)
IF(Subversion_FOUND)
	Subversion_WC_INFO(${PROJECT_SOURCE_DIR} OVITO_PROJ)
	# The current revision number is made accessible from the source code through the OVITO_PROJ_REPOSITORY_REVISION macro.
	ADD_DEFINITIONS("-DOVITO_PROJ_REPOSITORY_REVISION=${OVITO_PROJ_WC_REVISION}")
ELSE(Subversion_FOUND)
	ADD_DEFINITIONS("-DOVITO_PROJ_REPOSITORY_REVISION=0")
ENDIF(Subversion_FOUND)

# Use pre-compiled headers
OPTION(OVITO_USE_PRECOMPILED_HEADERS "Enable the generation of precompiled headers to speed up compilation." "ON")
SET(PCH_INCLUDE_FILE "cmake/PCHSupport_${CMAKE_MAJOR_VERSION}${CMAKE_MINOR_VERSION}.cmake")
IF(NOT EXISTS "${CMAKE_SOURCE_DIR}/${PCH_INCLUDE_FILE}")
	IF(OVITO_USE_PRECOMPILED_HEADERS)
		MESSAGE(FATAL_ERROR "The use of precompiled headers to build OVITO is not supported with this version of CMake. Please set the OVITO_USE_PRECOMPILED_HEADERS option to OFF.")
	ENDIF(OVITO_USE_PRECOMPILED_HEADERS)
ELSE(NOT EXISTS "${CMAKE_SOURCE_DIR}/${PCH_INCLUDE_FILE}")
	INCLUDE(${PCH_INCLUDE_FILE})
ENDIF(NOT EXISTS "${CMAKE_SOURCE_DIR}/${PCH_INCLUDE_FILE}")

# Build base module.
ADD_SUBDIRECTORY(src/base)

# Build mesh module.
ADD_SUBDIRECTORY(src/mesh)

# Build core module.
ADD_SUBDIRECTORY(src/core)

########## Build Plugins ##############

# Place all plugins libraries into the plugin directory.
FILE(MAKE_DIRECTORY ${OVITO_PLUGINS_DIRECTORY})
INSTALL(DIRECTORY DESTINATION ${OVITO_RELATIVE_PLUGINS_DIRECTORY})
SET(LIBRARY_OUTPUT_PATH "${OVITO_PLUGINS_DIRECTORY}")

########## Scripting Plugin ############
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	ADD_SUBDIRECTORY(src/scripting)
ELSE(OVITO_BUILD_PLUGIN_SCRIPTING)	
	FILE(REMOVE ${OVITO_PLUGINS_DIRECTORY}/Scripting.manifest.xml)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

########## Scripting GUI Plugin ############
IF(OVITO_BUILD_PLUGIN_SCRIPTING_GUI)
	ADD_SUBDIRECTORY(src/scripting_gui)
ELSE(OVITO_BUILD_PLUGIN_SCRIPTING_GUI)	
	FILE(REMOVE ${OVITO_PLUGINS_DIRECTORY}/ScriptingGUI.manifest.xml)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING_GUI)

############## POVRay Plugin ################
IF(OVITO_BUILD_PLUGIN_POVRAY)
	ADD_SUBDIRECTORY(src/povray)
ELSE(OVITO_BUILD_PLUGIN_POVRAY)	
	FILE(REMOVE ${OVITO_PLUGINS_DIRECTORY}/POVRay.manifest.xml)
ENDIF(OVITO_BUILD_PLUGIN_POVRAY)

############ StdObjects Plugin ##############
IF(OVITO_BUILD_PLUGIN_STDOBJECTS)
	ADD_SUBDIRECTORY(src/stdobjects)
ELSE(OVITO_BUILD_PLUGIN_STDOBJECTS)
	FILE(REMOVE ${OVITO_PLUGINS_DIRECTORY}/StdObjects.manifest.xml)
ENDIF(OVITO_BUILD_PLUGIN_STDOBJECTS)

############## AtomViz Plugin ###############
IF(OVITO_BUILD_PLUGIN_ATOMVIZ)
	ADD_SUBDIRECTORY(src/atomviz)
ELSE(OVITO_BUILD_PLUGIN_ATOMVIZ)	
	FILE(REMOVE ${OVITO_PLUGINS_DIRECTORY}/AtomViz.manifest.xml)
ENDIF(OVITO_BUILD_PLUGIN_ATOMVIZ)

############## CrystalAnalysis Plugin ###############
IF(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)
	ADD_SUBDIRECTORY(src/crystalanalysis)
ELSE(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)	
	FILE(REMOVE ${OVITO_PLUGINS_DIRECTORY}/CrystalAnalysis.manifest.xml)
ENDIF(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)

################# Main executable ####################

# Place the executable into the "bin" output directory.
SET(EXECUTABLE_OUTPUT_PATH ${OVITO_BINARY_DIRECTORY})
ADD_SUBDIRECTORY(src/mainexec)

################# Third-party DLLs ####################

# On Window the third-party library DLLs are usually not part of the system. 
# We need to copy them to the OVITO directory.
IF(WIN32)
	# Gather required Qt library DLLs.
	IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
		SET(QT_DLL_DEBUG_SUFFIX "d")
	ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")
	FOREACH(component "Core" "Gui" "OpenGL" "Help" "Xml")
		LIST(APPEND REQUIRED_DLLS "${QT_BINARY_DIR}/Qt${component}${QT_DLL_DEBUG_SUFFIX}${QT_VERSION_MAJOR}.dll")
	ENDFOREACH(component "Core" "Gui" "OpenGL" "Help" "Xml")
	
	# Gather required Boost library DLLs.
	SET(LIBLIST ${Boost_LIBRARIES})
	LIST(LENGTH LIBLIST LIBLIST_COUNT)
	WHILE(LIBLIST_COUNT)
		LIST(GET LIBLIST 0 LIB_NAME)
		SET(USE_LIB FALSE)
		IF(LIB_NAME STREQUAL "optimized" AND NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
			SET(USE_LIB TRUE)
		ENDIF(LIB_NAME STREQUAL "optimized" AND NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		IF(LIB_NAME STREQUAL "debug" AND CMAKE_BUILD_TYPE STREQUAL "Debug")
			SET(USE_LIB TRUE)
		ENDIF(LIB_NAME STREQUAL "debug" AND CMAKE_BUILD_TYPE STREQUAL "Debug")			
		IF(USE_LIB)
			LIST(REMOVE_AT LIBLIST 0)
			LIST(GET LIBLIST 0 LIB_NAME)
			STRING(REPLACE ".lib" ".dll" DLL_NAME ${LIB_NAME})
			LIST(APPEND REQUIRED_DLLS "${DLL_NAME}")
			IF(DLL_NAME MATCHES "boost_iostreams")
				STRING(REPLACE "iostreams" "zlib" DLL_NAME ${DLL_NAME})
				LIST(APPEND REQUIRED_DLLS "${DLL_NAME}")
			ENDIF(DLL_NAME MATCHES "boost_iostreams")
		ENDIF(USE_LIB)
		LIST(REMOVE_AT LIBLIST 0)
		LIST(LENGTH LIBLIST LIBLIST_COUNT)
	ENDWHILE(LIBLIST_COUNT)		
	
	# Copy library DLLs to output directory.
	FOREACH(dll ${REQUIRED_DLLS})
		CONFIGURE_FILE("${dll}" "${OVITO_BINARY_DIRECTORY}" COPYONLY)
		INSTALL(FILES "${dll}" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")
	ENDFOREACH(dll ${REQUIRED_DLLS})
ENDIF(WIN32)

################# Auxiliary files #######################

# Copy example files to output directory
COPY_DIRECTORY_WITHOUT_SVN("${CMAKE_SOURCE_DIR}/examples" "${OVITO_SHARE_DIRECTORY}/examples")
INSTALL(DIRECTORY "${OVITO_SHARE_DIRECTORY}/examples/" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/examples/")

################## Build documentation #####################

IF(OVITO_BUILD_DOCUMENTATION)
	INCLUDE(cmake/Documentation.cmake)
	ADD_DEPENDENCIES(ovito documentation)
	INSTALL(FILES "${OVITO_SHARE_DIRECTORY}/doc/manual/assistant/documentation.qhc" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/doc/manual/assistant/")
	INSTALL(FILES "${OVITO_SHARE_DIRECTORY}/doc/manual/assistant/documentation.qch" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/doc/manual/assistant/")
	INSTALL(DIRECTORY "${OVITO_SHARE_DIRECTORY}/doc/manual/html/" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/doc/manual/html/" PATTERN ".svn" EXCLUDE)
ENDIF(OVITO_BUILD_DOCUMENTATION)

#### Publish build configuration files for use by plugins #####

# Copy the CMAKE config files to destination directory.
# These are used to publish the current build settings to independent plugin projects
# that want to link to the OVITO core project. 
FILE(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/cmake")
CONFIGURE_FILE("OvitoConfig.cmake" "${PROJECT_BINARY_DIR}/" COPYONLY)
CONFIGURE_FILE("cmake/Version.cmake" "${PROJECT_BINARY_DIR}/cmake/" COPYONLY)
CONFIGURE_FILE("cmake/CompileQtResource.cmake" "${PROJECT_BINARY_DIR}/cmake/" COPYONLY)

######################### Setup CPack #######################
INCLUDE(cmake/Installation.cmake)

=== src/atomviz/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_ATOMVIZ")

# The header files that need to be processed by the QT meta-object compiler.
SET(AtomViz_MOC_HDRS
	atoms/AtomsObject.h
	atoms/AtomsObjectEditor.h
	atoms/AtomType.h	
	atoms/SimulationCell.h	
	atoms/AtomVizSettingsPage.h
	atoms/datachannels/DataChannel.h
	atoms/datachannels/AtomTypeDataChannel.h
	atoms/datachannels/PositionDataChannel.h
	atoms/datachannels/DisplacementDataChannel.h
	atoms/datachannels/OrientationDataChannel.h
	atoms/datachannels/DeformationGradientDataChannel.h
	atoms/datachannels/BondsDataChannel.h
	modifier/AtomsObjectModifierBase.h		
	modifier/AtomsObjectAnalyzerBase.h		
	modifier/slice/SliceModifier.h		
	modifier/coloring/AssignColorModifier.h		
	modifier/coloring/AtomTypeColorModifier.h		
	modifier/coloring/ColorCodingModifier.h
	modifier/ambientlighting/AmbientLightingModifier.h		
	modifier/analysis/cluster/ClusterAtomsModifier.h
	modifier/analysis/cna/CNAModifier.h
	modifier/analysis/ackland/AcklandAnalysisModifier.h	
	modifier/analysis/coordination/CoordinationNumberModifier.h
	modifier/datachannels/CreateExpressionChannelModifier.h		
	modifier/displacement/CalcDisplacementsModifier.h			
	modifier/selection/SelectAtomTypeModifier.h		
	modifier/selection/InvertSelectionModifier.h			
	modifier/selection/FreezeSelectionModifier.h			
	modifier/selection/SelectExpressionModifier.h
	modifier/selection/SelectionModifierBase.h
	modifier/deleteatoms/DeleteAtomsModifier.h
	modifier/transformation/AffineTransformationModifier.h
	modifier/wrap/WrapPeriodicImagesModifier.h	
	modifier/wrap/ShowPeriodicImagesModifier.h
	utils/NearestNeighborList.h
	utils/DataChannelComboBox.h
	parser/AtomsImportObject.h
	parser/AtomsFileParser.h 
	parser/AbstractFileColumnParser.h
	parser/MultiFileParser.h
	parser/ColumnChannelMapping.h
	parser/ColumnChannelMappingEditor.h
	parser/CompressedTextParserStream.h
	parser/xyz/XYZParser.h
	parser/xyz/XYZParserSettingsDialog.h
	parser/lammps/LAMMPSDataParser.h
	parser/lammps/LAMMPSDumpParser.h
	parser/lammps/LAMMPSDumpParserSettingsDialog.h
	parser/lammps/LAMMPSTextDumpParser.h
	parser/lammps/LAMMPSBinaryDumpParser.h
	parser/vasp/POSCARParser.h
	parser/imd/IMDAtomFileParser.h
	parser/imd/IMDParserSettingsDialog.h
	parser/dxa/DXAFileParser.h
	parser/dxa/DXAParserSettingsDialog.h
#	parser/cfg/CFGParser.h
	writer/AtomsFileWriter.h 
	writer/AbstractFileColumnWriter.h
	writer/MultiFileWriter.h	
	writer/ChannelColumnMapping.h
	writer/ChannelColumnMappingEditor.h
	writer/xyz/XYZWriter.h
	writer/xyz/XYZWriterSettingsDialog.h
	writer/lammps/LAMMPSDumpWriter.h
	writer/lammps/LAMMPSDumpWriterSettingsDialog.h
	writer/lammps/LAMMPSBinaryDumpWriter.h
	writer/lammps/LAMMPSTextDumpWriter.h
	writer/lammps/LAMMPSDataWriter.h
	writer/vasp/POSCARWriter.h
	writer/imd/IMDAtomFileWriter.h
	benchmark/AtomVizBenchmarkUtility.h
	utils/AtomInformationUtility.h
)

# The regular source files of this library.
SET(AtomViz_SRCS
	atoms/AtomsObject.cpp
	atoms/AtomsObjectEditor.cpp
	atoms/AtomType.cpp	
	atoms/SimulationCell.cpp		
	atoms/AtomsRenderer.cpp	
	atoms/AtomVizSettingsPage.cpp
	atoms/datachannels/DataChannel.cpp
	atoms/datachannels/AtomTypeDataChannel.cpp
	atoms/datachannels/PositionDataChannel.cpp
	atoms/datachannels/DisplacementDataChannel.cpp
	atoms/datachannels/OrientationDataChannel.cpp
	atoms/datachannels/DeformationGradientDataChannel.cpp
	atoms/datachannels/BondsDataChannel.cpp
	modifier/AtomsObjectModifierBase.cpp
	modifier/AtomsObjectAnalyzerBase.cpp
	modifier/slice/SliceModifier.cpp		
	modifier/coloring/AssignColorModifier.cpp		
	modifier/coloring/AtomTypeColorModifier.cpp		
	modifier/coloring/ColorCodingModifier.cpp
	modifier/ambientlighting/AmbientLightingModifier.cpp		
	modifier/analysis/cluster/ClusterAtomsModifier.cpp	
	modifier/analysis/cna/CNAModifier.cpp	
	modifier/analysis/ackland/AcklandAnalysisModifier.cpp	
	modifier/analysis/coordination/CoordinationNumberModifier.cpp
	modifier/datachannels/CreateExpressionChannelModifier.cpp		
	modifier/displacement/CalcDisplacementsModifier.cpp			
	modifier/selection/SelectAtomTypeModifier.cpp		
	modifier/selection/FreezeSelectionModifier.cpp			
	modifier/selection/InvertSelectionModifier.cpp			
	modifier/selection/SelectExpressionModifier.cpp			
	modifier/selection/SelectionModifierBase.cpp	
	modifier/deleteatoms/DeleteAtomsModifier.cpp				
	modifier/transformation/AffineTransformationModifier.cpp
	modifier/wrap/WrapPeriodicImagesModifier.cpp
	modifier/wrap/ShowPeriodicImagesModifier.cpp
	utils/ChemicalElements.cpp
	utils/NearestNeighborList.cpp
	utils/OnTheFlyNeighborList.cpp
	utils/AtomPicker.cpp
	utils/AtomInformationUtility.cpp
	parser/AtomsImportObject.cpp
	parser/AtomsFileParser.cpp
	parser/AbstractFileColumnParser.cpp
	parser/MultiFileParser.cpp
	parser/ColumnChannelMapping.cpp
	parser/ColumnChannelMappingEditor.cpp
	parser/xyz/XYZParser.cpp
	parser/xyz/XYZParserSettingsDialog.cpp
	parser/lammps/LAMMPSDataParser.cpp
	parser/lammps/LAMMPSDumpParser.cpp
	parser/lammps/LAMMPSDumpParserSettingsDialog.cpp
	parser/lammps/LAMMPSTextDumpParser.cpp
	parser/lammps/LAMMPSBinaryDumpParser.cpp
	parser/vasp/POSCARParser.cpp
	parser/imd/IMDAtomFileParser.cpp
	parser/imd/IMDParserSettingsDialog.cpp
	parser/dxa/DXAFileParser.cpp
	parser/dxa/DXAParserSettingsDialog.cpp
#	parser/cfg/CFGParser.cpp
	writer/AtomsFileWriter.cpp
	writer/AbstractFileColumnWriter.cpp
	writer/MultiFileWriter.cpp	
	writer/ChannelColumnMapping.cpp
	writer/ChannelColumnMappingEditor.cpp
	writer/xyz/XYZWriter.cpp
	writer/xyz/XYZWriterSettingsDialog.cpp
	writer/lammps/LAMMPSDumpWriter.cpp
	writer/lammps/LAMMPSDumpWriterSettingsDialog.cpp
	writer/lammps/LAMMPSBinaryDumpWriter.cpp
	writer/lammps/LAMMPSTextDumpWriter.cpp
	writer/lammps/LAMMPSDataWriter.cpp
	writer/vasp/POSCARWriter.cpp
	writer/imd/IMDAtomFileWriter.cpp
	benchmark/AtomVizBenchmarkUtility.cpp
)

# The source files of the muParser library.
SET(AtomViz_muParser_SRCS
	utils/muparser/muParser.cpp
	utils/muparser/muParserBytecode.cpp
	utils/muparser/muParserTest.cpp
	utils/muparser/muParserDLL.cpp
	utils/muparser/muParserInt.cpp
	utils/muparser/muParserTokenReader.cpp
	utils/muparser/muParserError.cpp
	utils/muparser/muParserCallback.cpp
	utils/muparser/muParserBase.cpp
)

# Add optional source file needed for POV-Ray export of atoms.
IF(OVITO_BUILD_PLUGIN_POVRAY)
	SET(AtomViz_SRCS ${AtomViz_SRCS} writer/Atoms2POVRay.cpp)
	SET(AtomViz_MOC_HDRS ${AtomViz_MOC_HDRS} writer/Atoms2POVRay.h)
ENDIF(OVITO_BUILD_PLUGIN_POVRAY)

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS AND MSVC)
	SET_SOURCE_FILES_PROPERTIES(${AtomViz_SRCS} PROPERTIES COMPILE_FLAGS "/Yucore/Core.h /Fpatomviz.pch")
	SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Yccore/Core.h /Fpatomviz.pch")
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND MSVC)

# Add optional source files needed for scripting of the plugin.
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	SET(AtomViz_SRCS ${AtomViz_SRCS} python/PythonInterface.cpp)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(AtomViz_MOC_SRCS ${AtomViz_MOC_HDRS})

# Generate plugin module.
ADD_LIBRARY(AtomViz 
	PrecompiledHeader.cpp	 
	${AtomViz_SRCS}
	${AtomViz_MOC_SRCS}	
	${AtomViz_muParser_SRCS}
)

IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	ADD_PRECOMPILED_HEADER(AtomViz ${CMAKE_SOURCE_DIR}/src/core/Core.h)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# Link required libraries
TARGET_LINK_LIBRARIES(AtomViz Base Core Mesh)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(AtomViz ${QT_LIBRARIES})

# Link the target against the OpenGL libraries. 
TARGET_LINK_LIBRARIES(AtomViz ${OPENGL_glu_LIBRARY})

# Link to Boost IOStreams library
TARGET_LINK_LIBRARIES(AtomViz ${Boost_LIBRARIES})

# On Mac OS, we must explicitely link the Boost zlib library.
IF(APPLE)
	FIND_LIBRARY(BOOST_ZLIB_LIBRARY NAMES "boost_zlib" PATHS ${Boost_LIBRARY_DIRS})	
	TARGET_LINK_LIBRARIES(AtomViz ${BOOST_ZLIB_LIBRARY})
ENDIF(APPLE)

# Add Python libraries for scripting
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	TARGET_LINK_LIBRARIES(AtomViz Scripting ${Boost_PYTHON_LIBRARY} ${PYTHON_UTIL_LIBRARY} ${PYTHON_LIBRARIES})
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# Link to POV-Ray plugin when POV-Ray export is enabled.
IF(OVITO_BUILD_PLUGIN_POVRAY)
	TARGET_LINK_LIBRARIES(AtomViz POVRay)
ENDIF(OVITO_BUILD_PLUGIN_POVRAY)

# Build the resource files for this plugin.
QT4_COMPILE_RESOURCES(AtomViz ${OVITO_PLUGINS_DIRECTORY}/atomviz.rcc resources/atomviz.qrc)

# Assign an absolute install path to this dynamic link library.
IF(APPLE)
	SET_TARGET_PROPERTIES(AtomViz PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(APPLE)

# Copy plugin manifest to destination directory.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/resources/AtomViz.manifest.xml" 
               "${OVITO_PLUGINS_DIRECTORY}/AtomViz.manifest.xml")

# Install script files for this plugin.
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	COPY_DIRECTORY_WITHOUT_SVN("${CMAKE_CURRENT_SOURCE_DIR}/resources/scripts" "${OVITO_SHARE_DIRECTORY}/scripts/atomviz")
	INSTALL(DIRECTORY "${OVITO_SHARE_DIRECTORY}/scripts/atomviz" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/scripts/" PATTERN ".svn" EXCLUDE)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# This plugin will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS AtomViz DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(NOT OVITO_MONOLITHIC_BUILD)
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/AtomViz.manifest.xml" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/atomviz.rcc" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")

=== src/base/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_BASE")

# The header files that need to be processed by the QT meta-object compiler.
SET(Base_MOC_HDRS
	io/LoadStream.h
	io/SaveStream.h
)

# The regular source files of this library.
SET(Base_SRCS
	io/LoadStream.cpp 
	io/SaveStream.cpp 
	
	linalg/AffineDecomposition.cpp 
	linalg/Box2.cpp 
	linalg/Box3.cpp 
	linalg/AffineTransformation.cpp 
	linalg/Matrix3.cpp 
	linalg/Matrix4.cpp 
	linalg/Plane.cpp 
	linalg/Point3.cpp 
	linalg/Quaternion.cpp 
	linalg/Ray.cpp 
	linalg/Rotation.cpp 
	linalg/Scaling.cpp 	
	linalg/Tensor.cpp 
	linalg/Vector3.cpp 	
	
	utilities/Exception.cpp
	utilities/Logger.cpp	
)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(Base_MOC_SRCS ${Base_MOC_HDRS})

# Create shared library.
ADD_LIBRARY(Base 
	PrecompiledHeader.cpp	 
	${Base_SRCS}
	${Base_MOC_SRCS}
)

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS)
	IF(MSVC)
		SET_SOURCE_FILES_PROPERTIES(${Base_SRCS} PROPERTIES COMPILE_FLAGS "/Yubase/Base.h /Fpbase.pch")
		SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Ycbase/Base.h /Fpbase.pch")
	ENDIF(MSVC)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		ADD_PRECOMPILED_HEADER(Base ${CMAKE_SOURCE_DIR}/src/base/Base.h)  
	ENDIF(CMAKE_COMPILER_IS_GNUCXX)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(Base ${QT_LIBRARIES})

# This library will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS Base DESTINATION ${OVITO_RELATIVE_LIBRARY_DIRECTORY})
ENDIF(NOT OVITO_MONOLITHIC_BUILD)

=== src/core/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_CORE")

# The header files that need to be processed by the QT meta-object compiler.
SET(Core_MOC_HDRS
	actions/Action.h
	actions/ActionProxy.h
	actions/ActionManager.h
	actions/ApplyModifierAction.h
	actions/ViewportModeAction.h
	actions/stdactions/StdActions.h
	actions/stdactions/XFormSystemChooser.h

	data/CurrentSelectionProxy.h
	data/DataSet.h
	data/DataSetManager.h
	data/ObjectLoadStream.h
	data/ObjectSaveStream.h

	data/importexport/ImporterExporter.h
	data/importexport/ImportExportManager.h

	data/units/ParameterUnit.h
 
	gui/ApplicationManager.h
	gui/ColorPickerWidget.h
	gui/SpinnerWidget.h
	gui/RolloutContainer.h
	gui/ElidedTextLabel.h

	gui/mainwnd/MainFrame.h
	gui/mainwnd/MainMenu.h
	gui/mainwnd/SettingsDialog.h

	gui/panels/CommandPanel.h
	gui/panels/CreationCommandPage.h	
	gui/panels/UtilityCommandPage.h		
	gui/panels/modify/ModifyCommandPage.h	
	gui/panels/modify/ModifierStack.h	
	gui/panels/animation/AnimationSettingsDialog.h	
	gui/panels/animation/AnimationTimeSlider.h
	gui/panels/render/RenderCommandPage.h

	gui/properties/AffineTransformationPropertyUI.h
	gui/properties/BooleanControllerUI.h
	gui/properties/BooleanGroupBoxControllerUI.h	
	gui/properties/BooleanGroupBoxPropertyUI.h	
	gui/properties/BooleanPropertyUI.h
	gui/properties/BooleanActionPropertyUI.h
	gui/properties/BooleanRadioButtonPropertyUI.h
	gui/properties/ColorControllerUI.h
	gui/properties/ColorPropertyUI.h
	gui/properties/FilenamePropertyUI.h	
	gui/properties/FloatControllerUI.h
	gui/properties/FloatPropertyUI.h
	gui/properties/IntegerControllerUI.h
	gui/properties/IntegerPropertyUI.h	
	gui/properties/IntegerRadioButtonPropertyUI.h
	gui/properties/NumericalControllerUI.h
	gui/properties/NumericalPropertyUI.h
	gui/properties/ParameterUI.h
	gui/properties/PropertiesEditor.h
	gui/properties/PropertiesPanel.h
	gui/properties/RefTargetListParameterUI.h
	gui/properties/StringPropertyUI.h
	gui/properties/VariantComboBoxPropertyUI.h	
	gui/properties/SubObjectParameterUI.h
	gui/properties/VectorControllerUI.h
	gui/properties/Vector3PropertyUI.h

	plugins/Plugin.h
	plugins/NativePlugin.h
	plugins/PluginClass.h
	plugins/PluginManager.h

	plugins/autostart/AutoStart.h	

	plugins/branding/Branding.h
	plugins/branding/UIEventFilter.h	

	plugins/utility/UtilityPlugin.h

	reference/CloneHelper.h
	reference/CustomAttributesContainer.h
	reference/RefMaker.h
	reference/RefTarget.h
	reference/RefTargetListener.h

	rendering/RenderSettings.h
	rendering/RenderSettingsEditor.h
	rendering/FrameBuffer.h
	rendering/FrameBufferWidget.h	
	rendering/FrameBufferWindow.h		
	rendering/PluginRenderer.h
	
	rendering/previewrenderer/PreviewRenderer.h
	rendering/previewrenderer/PreviewRendererEditor.h

	scene/GroupNode.h
	scene/ObjectNode.h
	scene/SceneNode.h
	scene/SceneRoot.h
	scene/SelectionSet.h		
	
	scene/animation/AnimationSettings.h		
	scene/animation/AnimManager.h	
	scene/animation/AnimationTimeSpinner.h
	
	scene/animation/controller/Controller.h	
	scene/animation/controller/LookAtController.h	
	scene/animation/controller/StandardConstControllers.h	
	scene/animation/controller/StandardLinearControllers.h
	scene/animation/controller/StandardSplineControllers.h
	scene/animation/controller/TransformationController.h	

	scene/material/Material.h

	scene/objects/CreationMode.h
	scene/objects/ModifiedObject.h
	scene/objects/Modifier.h
	scene/objects/ModifierApplication.h
	scene/objects/PipelineFlowState.h
	scene/objects/SceneObject.h
	scene/objects/AbstractCameraObject.h
	
	scene/objects/geometry/MeshObject.h
	scene/objects/geometry/SimpleGeometryObject.h 

	scene/objects/shapes/ShapeObject.h
	scene/objects/shapes/SimpleShapeObject.h 

	undo/UndoManager.h

	utilities/PathManager.h	
	utilities/ProgressIndicator.h	

	viewport/DefaultSceneRenderer.h
	viewport/ViewportMenu.h
	viewport/ViewportConfiguration.h
	viewport/OpenGLShader.h		
	viewport/SceneRenderer.h
	viewport/Viewport.h
	viewport/ViewportGrid.h
	viewport/ViewportManager.h
	viewport/ViewportPanel.h
	viewport/Window3D.h
	viewport/Window3DContainer.h		
	
	viewport/input/MoveMode.h
	viewport/input/NavigationModes.h
	viewport/input/RotationMode.h
	viewport/input/ScalingMode.h
	viewport/input/SelectionMode.h
	viewport/input/ViewportInputHandler.h
	viewport/input/ViewportInputManager.h
	viewport/input/XFormManager.h
	viewport/input/XFormMode.h		

	viewport/snapping/GridSnappingProvider.h
	viewport/snapping/SnappingManager.h
	viewport/snapping/SnappingProvider.h
)

# The regular source files of this library.
SET(Core_SRCS
	actions/Action.cpp
	actions/ActionProxy.cpp
	actions/ActionManager.cpp
	actions/ViewportModeAction.cpp
	actions/ApplyModifierAction.cpp
	
	actions/stdactions/AnimationActions.cpp
	actions/stdactions/EditingActions.cpp
	actions/stdactions/FileActions.cpp
	actions/stdactions/ViewportActions.cpp
	actions/stdactions/XFormSystemChooser.cpp
	actions/stdactions/RenderingActions.cpp
	actions/stdactions/OptionsActions.cpp

	data/CurrentSelectionProxy.cpp
	data/DataSet.cpp
	data/DataSetManager.cpp	
	data/ObjectLoadStream.cpp
	data/ObjectSaveStream.cpp
	
	data/importexport/ImportExportManager.cpp		
	data/units/ParameterUnit.cpp		
	
	gui/ApplicationManager.cpp
	gui/ColorPickerWidget.cpp
	gui/SpinnerWidget.cpp
	gui/RolloutContainer.cpp

	gui/mainwnd/MainFrame.cpp
	gui/mainwnd/MainMenu.cpp 
	gui/mainwnd/SettingsDialog.cpp

	gui/panels/CommandPanel.cpp
	gui/panels/CreationCommandPage.cpp	
	gui/panels/UtilityCommandPage.cpp
	gui/panels/modify/ModifyCommandPage.cpp
	gui/panels/modify/ModifierStack.cpp
	gui/panels/animation/AnimationSettingsDialog.cpp	
	gui/panels/animation/AnimationTimeSlider.cpp
	gui/panels/render/RenderCommandPage.cpp

	gui/properties/AffineTransformationPropertyUI.cpp
	gui/properties/BooleanControllerUI.cpp
	gui/properties/BooleanGroupBoxControllerUI.cpp
	gui/properties/BooleanGroupBoxPropertyUI.cpp	
	gui/properties/BooleanPropertyUI.cpp
	gui/properties/BooleanActionPropertyUI.cpp	
	gui/properties/BooleanRadioButtonPropertyUI.cpp
	gui/properties/ColorControllerUI.cpp
	gui/properties/ColorPropertyUI.cpp
	gui/properties/FilenamePropertyUI.cpp
	gui/properties/FloatControllerUI.cpp
	gui/properties/FloatPropertyUI.cpp
	gui/properties/IntegerControllerUI.cpp
	gui/properties/IntegerPropertyUI.cpp
	gui/properties/IntegerRadioButtonPropertyUI.cpp
	gui/properties/NumericalControllerUI.cpp
	gui/properties/NumericalPropertyUI.cpp
	gui/properties/ParameterUI.cpp
	gui/properties/PropertiesEditor.cpp
	gui/properties/PropertiesPanel.cpp
	gui/properties/RefTargetListParameterUI.cpp
	gui/properties/StringPropertyUI.cpp
	gui/properties/VariantComboBoxPropertyUI.cpp
	gui/properties/SubObjectParameterUI.cpp
	gui/properties/VectorControllerUI.cpp
	gui/properties/Vector3PropertyUI.cpp

	plugins/Plugin.cpp
	plugins/NativePlugin.cpp
	plugins/PluginClass.cpp
	plugins/PluginClassDescriptor.cpp
	plugins/NativePluginClassDescriptor.cpp
	plugins/PluginManager.cpp
	
	plugins/autostart/AutoStart.cpp	
	plugins/branding/Branding.cpp	
	plugins/utility/UtilityPlugin.cpp	
	
	reference/CloneHelper.cpp
	reference/CustomAttributesContainer.cpp
	reference/PropertyFieldDescriptor.cpp
	reference/RefMaker.cpp
	reference/RefTarget.cpp
	reference/RefTargetListener.cpp
	
	rendering/RenderSettings.cpp
	rendering/RenderSettingsEditor.cpp
	rendering/FrameBuffer.cpp
	rendering/FrameBufferWidget.cpp
	rendering/FrameBufferWindow.cpp
	rendering/PluginRenderer.cpp
	
	rendering/previewrenderer/PreviewRenderer.cpp
	rendering/previewrenderer/PreviewRendererEditor.cpp
	
	scene/GroupNode.cpp
	scene/ObjectNode.cpp
	scene/SceneNode.cpp
	scene/SceneRoot.cpp
	scene/SelectionSet.cpp		
	
	scene/animation/AnimationSettings.cpp		
	scene/animation/AnimManager.cpp	
	
	scene/animation/controller/Controller.cpp	
	scene/animation/controller/LookAtController.cpp	
	scene/animation/controller/StandardControllers.cpp	
	scene/animation/controller/TransformationController.cpp	

	scene/material/Material.cpp

	scene/objects/CreationMode.cpp
	scene/objects/ModifiedObject.cpp
	scene/objects/Modifier.cpp
	scene/objects/ModifierApplication.cpp
	scene/objects/PipelineFlowState.cpp
	scene/objects/SceneObject.cpp

	scene/objects/geometry/MeshObject.cpp
	scene/objects/geometry/SimpleGeometryObject.cpp 

	scene/objects/shapes/ShapeObject.cpp
	scene/objects/shapes/SimpleShapeObject.cpp 

	scene/bezier/BezierCurve.cpp
	scene/bezier/BezierPolygon.cpp
	scene/bezier/BezierShape.cpp

	undo/UndoManager.cpp

	utilities/PathManager.cpp	
	utilities/ProgressIndicator.cpp	

	viewport/DefaultSceneRenderer.cpp
	viewport/OpenGLInterface.cpp		
	viewport/OpenGLShader.cpp		
	viewport/SceneRenderer.cpp
	viewport/Viewport.cpp
	viewport/ViewportGrid.cpp
	viewport/ViewportManager.cpp
	viewport/ViewportMenu.cpp
	viewport/ViewportPanel.cpp
	viewport/ViewportConfiguration.cpp
	viewport/Window3D.cpp	
	viewport/Window3DContainer.cpp		
	viewport/Window3DHitTests.cpp	
	viewport/Window3DRender.cpp	
	
	viewport/input/MoveMode.cpp
	viewport/input/NavigationModes.cpp
	viewport/input/RotationMode.cpp
	viewport/input/ScalingMode.cpp
	viewport/input/SelectionMode.cpp
	viewport/input/ViewportInputHandler.cpp
	viewport/input/ViewportInputManager.cpp
	viewport/input/XFormManager.cpp
	viewport/input/XFormMode.cpp		

	viewport/snapping/GridSnappingProvider.cpp
	viewport/snapping/SnappingManager.cpp
	viewport/snapping/SnappingProvider.cpp
)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(Core_MOC_SRCS ${Core_MOC_HDRS})

# Include a resource file in the library.
QT4_ADD_RESOURCES(Core_RC_SRCS resources/core.qrc)

ADD_LIBRARY(Core
	PrecompiledHeader.cpp	 
	${Core_SRCS}
	${Core_MOC_SRCS}
	${Core_RC_SRCS}
)

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS)
	IF(MSVC)
		SET_SOURCE_FILES_PROPERTIES(${Core_SRCS} PROPERTIES COMPILE_FLAGS "/Yucore/Core.h /Fpcore.pch")
		SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Yccore/Core.h /Fpcore.pch")
	ENDIF(MSVC)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		ADD_PRECOMPILED_HEADER(Core ${CMAKE_SOURCE_DIR}/src/core/Core.h)  
	ENDIF(CMAKE_COMPILER_IS_GNUCXX)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS)

TARGET_LINK_LIBRARIES(Core Base Mesh)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(Core ${QT_LIBRARIES})

# Link the target against the OpenGL library (Required only when building a DLL for Windows). 
IF(WIN32)
	TARGET_LINK_LIBRARIES(Core ${OPENGL_gl_LIBRARY})
ENDIF(WIN32)

# Add Boost.Python libraries for scripting
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	TARGET_LINK_LIBRARIES(Core ${Boost_PYTHON_LIBRARY} ${PYTHON_UTIL_LIBRARY} ${PYTHON_LIBRARIES})
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

IF(NOT OVITO_MONOLITHIC_BUILD)
	# This library will be part of the installation package.
	INSTALL(TARGETS Core DESTINATION ${OVITO_RELATIVE_LIBRARY_DIRECTORY})

=== src/crystalanalysis/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# This plugin relies on the AtomViz plugin.
IF(NOT OVITO_BUILD_PLUGIN_ATOMVIZ)
	MESSAGE(FATAL_ERROR "To build the CrystalAnalysis plugin the AtomViz plugin has to be enabled too. Please set the OVITO_BUILD_PLUGIN_ATOMVIZ option to ON.")
ENDIF(NOT OVITO_BUILD_PLUGIN_ATOMVIZ)

# Find GNU Scientific Library (GSL)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})
FIND_PACKAGE(GSL)
IF(NOT GSL_FOUND)
	MESSAGE(FATAL_ERROR "The GNU Scientific Library (GSL) was not found on your system but is required for the Crystal Analysis plugin. Please install this library on your system or specify the location of the library manually.")
ENDIF(NOT GSL_FOUND)
INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIR})

# Find Computational Geometry Algorithms Library (CGAL)
#FIND_PACKAGE(CGAL)
#IF(NOT CGAL_FOUND)
#	MESSAGE(FATAL_ERROR "The Computational Geometry Algorithms Library (CGAL) was not found on your system but is required for the Crystal Analysis plugin. Please install this library on your system or specify the location of the library manually.")
#ENDIF(NOT CGAL_FOUND)
#INCLUDE_DIRECTORIES(${CGAL_INCLUDE_DIR})

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_CRYSTALANALYSIS")

# The header files that need to be processed by the QT meta-object compiler.
SET(CrystalAnalysis_MOC_HDRS
	grains/AnalyzeMicrostructureModifier.h
	deformation/CalculateExtrinsicStrainModifier.h
	deformation/CalculateIntrinsicStrainModifier.h
#	alphashape/AlphaShapeUtility.h
)

# The regular source files of this library.
SET(CrystalAnalysis_SRCS
	grains/AnalyzeMicrostructureModifier.cpp
	grains/FindGrains.cpp
	deformation/CalculateExtrinsicStrainModifier.cpp
	deformation/CalculateIntrinsicStrainModifier.cpp
#	alphashape/AlphaShapeUtility.cpp
)

# AlphaShapeUtility.cpp implicitely includes "/usr/include/c++/4.3/ext/hash_set" which uses depreciated functions. Turn off the compiler warings.
#SET_SOURCE_FILES_PROPERTIES(alphashape/AlphaShapeUtility.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated")

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS AND MSVC)
	SET_SOURCE_FILES_PROPERTIES(${AtomViz_SRCS} PROPERTIES COMPILE_FLAGS "/Yucore/Core.h /Fpcrystalanalysis.pch")
	SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Yccore/Core.h /Fpcrystalanalysis.pch")
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND MSVC)

# Add optional source files needed for scripting of the plugin.
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	SET(CrystalAnalysis_SRCS ${CrystalAnalysis_SRCS} python/PythonInterface.cpp)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(CrystalAnalysis_MOC_SRCS ${CrystalAnalysis_MOC_HDRS})

# Generate plugin module.
ADD_LIBRARY(CrystalAnalysis 
	PrecompiledHeader.cpp	 
	${CrystalAnalysis_SRCS}
	${CrystalAnalysis_MOC_SRCS}	
)

IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	ADD_PRECOMPILED_HEADER(CrystalAnalysis ${CMAKE_SOURCE_DIR}/src/core/Core.h)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# Link required libraries
TARGET_LINK_LIBRARIES(CrystalAnalysis Base Core Mesh AtomViz)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(CrystalAnalysis ${QT_LIBRARIES})

# Add GSL library
TARGET_LINK_LIBRARIES(CrystalAnalysis ${GSL_LIBRARIES})

# Add CGAL library
#TARGET_LINK_LIBRARIES(CrystalAnalysis ${CGAL_LIBRARIES})

# Add Python libraries for scripting
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	TARGET_LINK_LIBRARIES(CrystalAnalysis Scripting ${BOOST_PYTHON_LIB} ${PYTHON_UTIL_LIBRARY} ${PYTHON_LIBRARIES})
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# Build the resource files for this plugin.
QT4_COMPILE_RESOURCES(CrystalAnalysis ${OVITO_PLUGINS_DIRECTORY}/crystalanalysis.rcc resources/crystalanalysis.qrc)

# Assign an absolute install path to this dynamic link library.
IF(APPLE)
	SET_TARGET_PROPERTIES(CrystalAnalysis PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(APPLE)

# Copy plugin manifest to destination directory.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/resources/CrystalAnalysis.manifest.xml" 
               "${OVITO_PLUGINS_DIRECTORY}/CrystalAnalysis.manifest.xml")

# Install script files for this plugin.
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	COPY_DIRECTORY_WITHOUT_SVN("${CMAKE_CURRENT_SOURCE_DIR}/resources/scripts" "${OVITO_SHARE_DIRECTORY}/scripts/crystalanalysis")
	INSTALL(DIRECTORY "${OVITO_SHARE_DIRECTORY}/scripts/crystalanalysis" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/scripts/" PATTERN ".svn" EXCLUDE)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# This plugin will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS CrystalAnalysis DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(NOT OVITO_MONOLITHIC_BUILD)
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/CrystalAnalysis.manifest.xml" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/crystalanalysis.rcc" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")

=== src/mainexec/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Include the resource in the Win32 executable.
IF(WIN32)
	SET(WINDOWS_RESOURCES resources/ovito.rc)
ENDIF(WIN32)

# Builds the main executable of the application
ADD_EXECUTABLE(${PROJECT_NAME} MACOSX_BUNDLE Main.cpp ${WINDOWS_RESOURCES})

# The executable directly depends on the core modules.
TARGET_LINK_LIBRARIES(${PROJECT_NAME} Base Mesh Core)

# If we build a monolithic executable that includes all plugins then
# we have to make it dependent on these too.
#
# When statically linking the plugin libraries the linker we eliminate
# unreferenced static objects in these libraries. To prevent this from
# happening we have to use the -whole-archive linker option. 
IF(OVITO_MONOLITHIC_BUILD)

	# For the static version of the program we need to give another name to the executable
	# because it gets replaced with a script that sets the library paths before executing
	# the actual program.
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "ovitostatic")

	# Copy the shell script to the output directory that launches the static executable.
	CONFIGURE_FILE("resources/ovito" "${OVITO_BINARY_DIRECTORY}/ovito" COPYONLY)
	INSTALL(PROGRAMS "resources/ovito" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")
	
	# This macro adds a static library target to an executable target and makes sure that
	# the library is linked completely into the executable without removal of unreferenced
	# objects.
	MACRO(LINK_WHOLE_LIBRARY _targetName _libraryTarget)
		GET_TARGET_PROPERTY(EXE_LINKER_OPTIONS ${_targetName} LINK_FLAGS)
		IF(NOT EXE_LINKER_OPTIONS)
			SET(EXE_LINKER_OPTIONS "")
		ENDIF(NOT EXE_LINKER_OPTIONS)	
		GET_TARGET_PROPERTY(TARGET_LOCATION ${_libraryTarget} LOCATION)
		SET(EXE_LINKER_OPTIONS "${EXE_LINKER_OPTIONS} -Wl,-whole-archive ${TARGET_LOCATION} -Wl,-no-whole-archive ")
		SET_TARGET_PROPERTIES(${_targetName} PROPERTIES LINK_FLAGS ${EXE_LINKER_OPTIONS})
		TARGET_LINK_LIBRARIES(${_targetName} ${_libraryTarget})
	ENDMACRO(LINK_WHOLE_LIBRARY)

	LINK_WHOLE_LIBRARY(${PROJECT_NAME} Core)
	IF(OVITO_BUILD_PLUGIN_SCRIPTING)
		LINK_WHOLE_LIBRARY(${PROJECT_NAME} Scripting)
	ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)
	IF(OVITO_BUILD_PLUGIN_SCRIPTING_GUI)
		LINK_WHOLE_LIBRARY(${PROJECT_NAME} ScriptingGUI)
	ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING_GUI)
	IF(OVITO_BUILD_PLUGIN_POVRAY)
		LINK_WHOLE_LIBRARY(${PROJECT_NAME} POVRay)
	ENDIF(OVITO_BUILD_PLUGIN_POVRAY)
	IF(OVITO_BUILD_PLUGIN_RENDERMAN)
		LINK_WHOLE_LIBRARY(${PROJECT_NAME} RenderMan)
	ENDIF(OVITO_BUILD_PLUGIN_RENDERMAN)
	IF(OVITO_BUILD_PLUGIN_STDOBJECTS)
		LINK_WHOLE_LIBRARY(${PROJECT_NAME} StdObjects)
	ENDIF(OVITO_BUILD_PLUGIN_STDOBJECTS)
	IF(OVITO_BUILD_PLUGIN_ATOMVIZ)
		LINK_WHOLE_LIBRARY(${PROJECT_NAME} AtomViz)
	ENDIF(OVITO_BUILD_PLUGIN_ATOMVIZ)
	IF(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)
		LINK_WHOLE_LIBRARY(${PROJECT_NAME} CrystalAnalysis)
	ENDIF(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)
ENDIF(OVITO_MONOLITHIC_BUILD)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${QT_LIBRARIES})

# This executable will be part of the installation package.
INSTALL(TARGETS ${PROJECT_NAME} DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")

# Copy the application's Linux desktop file to the system's application directory.
IF(UNIX AND NOT APPLE)
	INSTALL(FILES "resources/ovito.desktop" DESTINATION "share/applications")
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
	CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

	SET(APPS "\${CMAKE_INSTALL_PREFIX}/${MACOSX_BUNDLE_NAME}.app")
	
	# Install the Info.plist file.
	#CONFIGURE_FILE("resources/Info.plist" "${OVITO_BINARY_DIRECTORY}/${MACOSX_BUNDLE_NAME}.app/Contents/Info.plist")
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/resources/Info.plist")

	# Install needed Qt plugins by copying directories from the qt installation
	# One can cull what gets copied by using 'REGEX "..." EXCLUDE'
	SET(plugin_dest_dir "${MACOSX_BUNDLE_NAME}.app/Contents/MacOS")
	SET(qtconf_dest_dir "${MACOSX_BUNDLE_NAME}.app/Contents/Resources")
	INSTALL(DIRECTORY "${QT_PLUGINS_DIR}/imageformats" DESTINATION ${plugin_dest_dir}/plugins COMPONENT Runtime)

	# Install a qt.conf file.
	# This inserts some cmake code into the install script to write the file
	INSTALL(CODE "
	    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${qtconf_dest_dir}/qt.conf\" \"\")
	    " COMPONENT Runtime)

	# Use BundleUtilities to get all other dependencies for the application to work.
	# It takes a bundle or executable along with possible plugins and inspects it
	# for dependencies.  If they are not system dependencies, they are copied.

	# directories to look for dependencies
	SET(DIRS ${QT_LIBRARY_DIRS} ${Boost_LIBRARY_DIRS} "${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}" "${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/plugins/imageformats")

	# Now the work of copying dependencies into the bundle/package
	# The quotes are escaped and variables to use at install time have their $ escaped
	# An alternative is the do a configure_file() on a script and use install(SCRIPT  ...).
	# Note that the image plugins depend on QtSvg and QtXml, and it got those copied
	# over.
	INSTALL(CODE "
		# Returns the path that others should refer to the item by when the item is embedded inside a bundle.
		# This ensures that all plugin libraries go into the plugins/ directory of the bundle.
		FUNCTION(gp_item_default_embedded_path_override item default_embedded_path_var)
		    MESSAGE(\"gp_item_default_embedded_path_override item=\${item}\")
			# Let everything that is already in the bundle stay where it comes from.
	    	if(item MATCHES \"^.*/.*\\\\${MACOSX_BUNDLE_NAME}.app/.*$\")
			    MESSAGE(\"basepath= \${CMAKE_INSTALL_PREFIX}/${MACOSX_BUNDLE_NAME}.app/Contents/MacOS/\")
				FILE(RELATIVE_PATH relpath \"\${CMAKE_INSTALL_PREFIX}/${MACOSX_BUNDLE_NAME}.app/Contents/MacOS/\" \"\${item}\")
			    MESSAGE(\"relpath=\${relpath}\")
				GET_FILENAME_COMPONENT(relpath2 \${relpath} PATH)
			    MESSAGE(\"relpath2=\${relpath2}\")
			    SET(path \"@executable_path/\${relpath2}\")
			endif(item MATCHES \"^.*/.*\\\\${MACOSX_BUNDLE_NAME}.app/.*$\")
			SET(\${default_embedded_path_var} \"\${path}\" PARENT_SCOPE)
		ENDFUNCTION(gp_item_default_embedded_path_override)
		file(GLOB_RECURSE QTPLUGINS
			\"\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
		file(GLOB_RECURSE OVITO_PLUGINS
			\"\${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
		set(BUNDLE_LIBS \${QTPLUGINS} \${OVITO_PLUGINS})
		include(BundleUtilities)
		fixup_bundle(\"${APPS}\" \"\${BUNDLE_LIBS}\" \"${DIRS}\")
		" COMPONENT Runtime)
	    	
	# To Create a package, one can run "cpack -G DragNDrop CPackConfig.cmake" on Mac OS X
	# where CPackConfig.cmake is created by including CPack.
	SET(CPACK_BINARY_DRAGNDROP ON)		

ENDIF(APPLE)

=== src/povray/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_POVRAY")

# The header files that need to be processed by the QT meta-object compiler.
SET(POVRay_MOC_HDRS
	export/POVRayExporter.h
	export/POVRayExportInterface.h
	export/MeshExportInterface.h	
	
	renderer/POVRayRenderer.h
	renderer/POVRayRendererEditor.h
)

# The regular source files of this library.
SET(POVRay_SRCS
	export/POVRayExporter.cpp
	export/MeshExportInterface.cpp	
	
	renderer/POVRayRenderer.cpp
	renderer/POVRayRendererEditor.cpp
)

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS AND MSVC)
	SET_SOURCE_FILES_PROPERTIES(${POVRay_SRCS} PROPERTIES COMPILE_FLAGS "/Yucore/Core.h /Fppovray.pch")
	SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Yccore/Core.h /Fppovray.pch")
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND MSVC)

# Add optional source files needed for scripting of the plugin.
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	SET(POVRay_SRCS ${POVRay_SRCS} 
		python/PythonInterface.cpp	
	)
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(POVRay_MOC_SRCS ${POVRay_MOC_HDRS})

# Create plugin library.
ADD_LIBRARY(POVRay
	PrecompiledHeader.cpp
	${POVRay_SRCS}
	${POVRay_MOC_SRCS}	
)

IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	ADD_PRECOMPILED_HEADER(POVRay ${CMAKE_SOURCE_DIR}/src/core/Core.h)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# Link required libraries
TARGET_LINK_LIBRARIES(POVRay Base Core Mesh)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(POVRay ${QT_LIBRARIES})

# Add Python libraries for scripting
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	TARGET_LINK_LIBRARIES(POVRay Scripting ${Boost_PYTHON_LIBRARY} ${PYTHON_UTIL_LIBRARY} ${PYTHON_LIBRARIES})
ENDIF(OVITO_BUILD_PLUGIN_SCRIPTING)

# Assign an absolute install path to this dynamic link library.
IF(APPLE)
	SET_TARGET_PROPERTIES(POVRay PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(APPLE)

# Copy Plugin manifest to destination directory.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/resources/POVRay.manifest.xml" 
               "${OVITO_PLUGINS_DIRECTORY}/POVRay.manifest.xml")
 
# This plugin will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS POVRay DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(NOT OVITO_MONOLITHIC_BUILD)
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/POVRay.manifest.xml" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")

=== src/scripting/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_SCRIPTING")

# The header files that need to be processed by the QT meta-object compiler.
SET(Scripting_MOC_HDRS
	engine/ScriptEngine.h
	engine/StartupScriptExecutor.h
	plugins/ScriptPlugin.h
)

# The regular source files of this library.
SET(Scripting_SRCS
	engine/ScriptEngine.cpp		
	engine/StartupScriptExecutor.cpp		
	plugins/ScriptPlugin.cpp
	plugins/ScriptPluginClassDescriptor.cpp
	interface/PythonInterface.cpp
	interface/LinAlg.cpp			
	interface/TriMesh.cpp			
	interface/Viewport.cpp			
	interface/Plugins.cpp
	interface/Reference.cpp		
	interface/Data.cpp
	interface/Scene.cpp	
	interface/Animation.cpp
	interface/Rendering.cpp
	interface/Actions.cpp
)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(Scripting_MOC_SRCS ${Scripting_MOC_HDRS})

# Create plugin library.
ADD_LIBRARY(Scripting
	PrecompiledHeader.cpp
	${Scripting_SRCS}
	${Scripting_MOC_SRCS}	
)

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS)
	IF(MSVC)
		SET_SOURCE_FILES_PROPERTIES(${Scripting_SRCS} PROPERTIES COMPILE_FLAGS "/Yuscripting/Scripting.h /Fpscripting.pch")
		SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Ycscripting/Scripting.h /Fpscripting.pch")
	ENDIF(MSVC)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		ADD_PRECOMPILED_HEADER(Scripting ${CMAKE_SOURCE_DIR}/src/core/Core.h)
	ENDIF(CMAKE_COMPILER_IS_GNUCXX)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS)

# Link required libraries
TARGET_LINK_LIBRARIES(Scripting Base Core)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(Scripting ${QT_LIBRARIES})

# Add Python libraries for scripting
TARGET_LINK_LIBRARIES(Scripting ${Boost_PYTHON_LIBRARY} ${PYTHON_UTIL_LIBRARY} ${PYTHON_LIBRARIES})

# Assign an absolute install path to this dynamic link library.
IF(APPLE)
	SET_TARGET_PROPERTIES(Scripting PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(APPLE)

# Copy Plugin manifest to destination directory.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/resources/Scripting.manifest.xml"
               "${OVITO_PLUGINS_DIRECTORY}/Scripting.manifest.xml")

# Create sub directories for the script files
FILE(MAKE_DIRECTORY "${OVITO_SHARE_DIRECTORY}/scripts")

# Copy the shell script to the output directory that can be used to launch the non-GUI script interpreter.
CONFIGURE_FILE("resources/ovitos" "${OVITO_BINARY_DIRECTORY}/ovitos" COPYONLY)
INSTALL(PROGRAMS "resources/ovitos" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")

# This plugin will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS Scripting DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(NOT OVITO_MONOLITHIC_BUILD)
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/Scripting.manifest.xml" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")

=== src/scripting_gui/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Make sure that the scripting plugin is also built.
IF(NOT OVITO_BUILD_PLUGIN_SCRIPTING)
	MESSAGE(FATAL_ERROR "Conflict: Cannot build the graphical user interface for the scripting plugin without building the scripting plugin. The build variable OVITO_BUILD_PLUGIN_SCRIPTING_GUI cannot be set to ON when the variable OVITO_BUILD_PLUGIN_SCRIPTING is set to OFF. Please resolve in the CMake settings editor.")
ENDIF(NOT OVITO_BUILD_PLUGIN_SCRIPTING)

# Find QScintilla library
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})
FIND_PACKAGE(QScintilla2)
IF(NOT QSCINTILLA2_FOUND)
	MESSAGE(FATAL_ERROR "The QScintilla library is required for the graphical scripting interface but was not found on your system. Please install this library or specify the location of the library manually.")
ENDIF(NOT QSCINTILLA2_FOUND)
INCLUDE_DIRECTORIES(${QSCINTILLA2_INCLUDE_DIR})

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_SCRIPTING_GUI")

# The header files that need to be processed by the QT meta-object compiler.
SET(Scripting_gui_MOC_HDRS
	ui/ScriptUtility.h
	ui/ScriptEditor.h
)

# The regular source files of this library.
SET(Scripting_gui_SRCS
	ui/ScriptUtility.cpp
	ui/ScriptEditor.cpp	
)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(Scripting_gui_MOC_SRCS ${Scripting_gui_MOC_HDRS})

# Create plugin library.
ADD_LIBRARY(ScriptingGUI
	PrecompiledHeader.cpp
	${Scripting_gui_SRCS}
	${Scripting_gui_MOC_SRCS}	
)

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS)
	IF(MSVC)
		SET_SOURCE_FILES_PROPERTIES(${Scripting_gui_SRCS} PROPERTIES COMPILE_FLAGS "/Yuscripting_gui/ScriptingGUI.h /Fpscripting_gui.pch")
		SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Ycscripting_gui/ScriptingGUI.h /Fpscripting_gui.pch")
	ENDIF(MSVC)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		ADD_PRECOMPILED_HEADER(ScriptingGUI ${CMAKE_SOURCE_DIR}/src/core/Core.h)
	ENDIF(CMAKE_COMPILER_IS_GNUCXX)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS)

# Link required libraries
TARGET_LINK_LIBRARIES(ScriptingGUI Base Core)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(ScriptingGUI ${QT_LIBRARIES})

# Link to base scripting plugin. 
TARGET_LINK_LIBRARIES(ScriptingGUI Scripting)

# Add QScintilla library
TARGET_LINK_LIBRARIES(ScriptingGUI ${QSCINTILLA2_LIBRARIES})

# Assign an absolute install path to this dynamic link library.
IF(APPLE)
	SET_TARGET_PROPERTIES(ScriptingGUI PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(APPLE)

# Copy Plugin manifest to destination directory.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/resources/ScriptingGUI.manifest.xml"
               "${OVITO_PLUGINS_DIRECTORY}/ScriptingGUI.manifest.xml")

# On Window the third-party library DLLs are usually not part of the system. 
# We need to copy them to the OVITO directory.
IF(WIN32)
	# Copy library DLL to output directory.
	STRING(REPLACE ".lib" ".dll" QSCINTILLA2_DLL ${QSCINTILLA2_LIBRARIES})
	CONFIGURE_FILE("${QSCINTILLA2_DLL}" "${OVITO_BINARY_DIRECTORY}" COPYONLY)
	INSTALL(FILES "${QSCINTILLA2_DLL}" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")
ENDIF(WIN32)			   
			   
# This plugin will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS ScriptingGUI DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(NOT OVITO_MONOLITHIC_BUILD)
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/ScriptingGUI.manifest.xml" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")

=== src/stdobjects/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2008) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Enable precompiled headers when using the GCC compiler.
IF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
ENDIF(OVITO_USE_PRECOMPILED_HEADERS AND CMAKE_COMPILER_IS_GNUCXX)

# This is needed to export the symbols in this shared library.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMAKING_MODULE_STDOBJECTS")

# The header files that need to be processed by the QT meta-object compiler.
SET(StdObjects_MOC_HDRS
	geometry/box/BoxObject.h
	geometry/box/BoxCreationMode.h
	geometry/cylinder/CylinderObject.h
	geometry/cylinder/CylinderCreationMode.h
	shapes/rectangle/RectangleObject.h
	shapes/rectangle/RectangleCreationMode.h
	shapes/circle/CircleObject.h
	shapes/circle/CircleCreationMode.h
	cameras/CameraObject.h
	cameras/FreeCameraCreationMode.h
	cameras/TargetCameraCreationMode.h	
	helpers/TargetObject.h
)

# The regular source files of this library.
SET(StdObject_SRCS
	geometry/box/BoxObject.cpp
	geometry/cylinder/CylinderObject.cpp
	shapes/rectangle/RectangleObject.cpp
	shapes/circle/CircleObject.cpp
	cameras/CameraObject.cpp
	helpers/TargetObject.cpp	
)

# Use the QT meta-object compiler to generate additional code.
QT4_WRAP_CPP(StdObjects_MOC_SRCS ${StdObjects_MOC_HDRS})

# Create plugin library.
ADD_LIBRARY(StdObjects
	PrecompiledHeader.cpp	 
	${StdObject_SRCS}
	${StdObjects_MOC_SRCS}	
)

# Generate precompiled header
IF(OVITO_USE_PRECOMPILED_HEADERS)
	IF(MSVC)
		SET_SOURCE_FILES_PROPERTIES(${StdObjects_SRCS} PROPERTIES COMPILE_FLAGS "/Yucore/Core.h /Fpstdobject.pch")
		SET_SOURCE_FILES_PROPERTIES(PrecompiledHeader.cpp PROPERTIES COMPILE_FLAGS "/Yccore/Core.h /Fpstdobject.pch")
	ENDIF(MSVC)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		ADD_PRECOMPILED_HEADER(StdObjects ${CMAKE_SOURCE_DIR}/src/core/Core.h)  
	ENDIF(CMAKE_COMPILER_IS_GNUCXX)
ENDIF(OVITO_USE_PRECOMPILED_HEADERS)

TARGET_LINK_LIBRARIES(StdObjects Base Core Mesh)

# Link the target against the Qt libraries. 
TARGET_LINK_LIBRARIES(StdObjects ${QT_LIBRARIES})

# Assign an absolute install path to this dynamic link library.
IF(APPLE)
	SET_TARGET_PROPERTIES(StdObjects PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(APPLE)

# Copy Plugin manifest to destination directory.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/resources/StdObjects.manifest.xml" 
			   "${OVITO_PLUGINS_DIRECTORY}/StdObjects.manifest.xml" COPYONLY)

# This plugin will be part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS StdObjects DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
ENDIF(NOT OVITO_MONOLITHIC_BUILD)
INSTALL(FILES "${OVITO_PLUGINS_DIRECTORY}/StdObjects.manifest.xml" DESTINATION "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")

=== debian/changelog ===
ovito (0.9.2-1) unstable; urgency=low

  * Initial release (Closes: #600812)

 -- Pekko Metsä <pjmetsa@gmail.com>  Sun, 31 Oct 2010 00:44:04 +0300

=== debian/control ===
Source: ovito
Section: science
Priority: extra
Maintainer: Pekko Metsä <pjmetsa@gmail.com>
Build-Depends: debhelper (>= 7.0.50), cmake, libboost-dev, libboost-iostreams-dev, libboost-python-dev, libqt4-opengl-dev, qt4-dev-tools, libgsl0-dev, xsltproc, docbook-xml, docbook-xsl, docbook-xsl-doc-html, libqscintilla2-dev, python-dev, libmuparser-dev
Standards-Version: 3.9.1
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Recommends: ovito-doc, ovito-examples
Suggests: povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: ovito, ovito-examples
Section: doc
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.

Package: ovito-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: ovito, ovito-doc
Section: doc
Description: tutorial examples for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the tutorial examples for ovito.
